/*
 * InputDefintion.cpp
 *
 *  Created on: 5 déc. 2020
 *      Author: fanch
 */

#include "InputDefinition.h"

#include "Button.h"
#include "Controller.h"
#include "PadDefinition.h"
AbsInput* InputDefinition::instanciate(PadDefinition* p, Json::Value& v)
{
    if(m_type==BUTTON)
    {
        Button* b = p->instanciate_new_button();
        b->x=b->y=0;
        b->realchannel = (!v.isMember("channel") || v["channel"].isNull())?-1:v["channel"].asInt();
        b->realkey = (!v.isMember("key") || v["key"].isNull())?-1:v["key"].asInt();
        b->realvel = 0;
        b->locked = "";
        b->m_actions = m_actions;

        return b;
    }
    else if(m_type==CONTROLLER)
    {
        Controller* b = p->instanciate_new_controller();
        b->x=b->y=0;
        b->realchannel = (!v.isMember("channel") || v["channel"].isNull())?-1:v["channel"].asInt();
        b->realkey = (!v.isMember("key") || v["key"].isNull())?-1:v["key"].asInt();
        b->realvel = 0;
        b->locked = "";
        b->m_actions = m_actions;
        return b;
    }
    return NULL;
}

